<?php
$default_options = array(
	'maxwidth' => '0',
	'lockheight' => '1',
	'height' => '400',
	'maxheight' => '0',
	'property5' => '1',
	'property2' => '10',
	'property3' => '14',
	'thumbSpace' => '10',
	'fancyBox' => '1',
	'showLink' => '1',
	'linkTarget' => '_self',
	'property4' => '1',
	'property0' => 'opaque',
	'property1' => 'ffffff',
	'property6' => '000000',
	'property7' => '75c30f',
	'property8' => 'ffffff',
	'property15' => '75c30f',
	'titleFontSize' => '12',
	'property16' => 'ffffff',
	'descriptionFontSize' => '11',
	'property13' => '000000',
	'property14' => '85',
	'customCSS' => ''
);
$options_tree = array(
	array(
		'label' => 'Gallery Settings',
		'fields' => array(
			'maxwidth' => array(
				'label' => 'Max-Width',
				'tag' => 'input',
				'attr' => 'type="number" min="0"',
				'text' => 'Set the maximum width of the gallery. Leave 0 to disable max-width.'
			),
			'lockheight' => array(
				'label' => 'Set height manually',
				'tag' => 'checkbox',
				'attr' => 'data-watch="change"',
				'text' => 'By default a gallery automatically calculates own height to best fit the tallest image in a gallery.'
			),
			'height' => array(
				'label' => 'Height',
				'tag' => 'input',
				'attr' => 'type="text" min="0" data-lockheight="is:1"',
				'text' => 'Set height of the gallery. Do not set % unless you know what you doing.'
			),
			'maxheight' => array(
				'label' => 'Max-Height',
				'tag' => 'input',
				'attr' => 'type="number" min="0" data-lockheight="is:0"',
				'text' => 'Set the maximum height of the gallery. Leave 0 to disable max-height.'
			),
			'property5' => array(
				'label' => 'Automatic Slideshow',
				'tag' => 'checkbox',
				'attr' => '',
				'text' => ''
			),
			'property2' => array(
				'label' => 'Slideshow Delay',
				'tag' => 'input',
				'attr' => 'type="number" min="1" max="60"',
				'text' => 'Set delay between slides in seconds'
			),
			'property3' => array(
				'label' => 'Bottom NavBar Height',
				'tag' => 'input',
				'attr' => 'type="number" min="14" max="30"',
				'text' => 'Set bottom navigation bar height in pixels'
			),
			'thumbSpace' => array(
				'label' => 'Image Horizontal Padding',
				'tag' => 'input',
				'attr' => 'type="number" min="6" max="30"',
				'text' => 'Set bottom thumbnails height in pixels'
			),
			'fancyBox' => array(
				'label' => 'Open Image in Lightbox',
				'tag' => 'checkbox',
				'attr' => '',
				'text' => ''
			),
			'showLink' => array(
				'label' => 'Show Link Icon',
				'tag' => 'checkbox',
				'attr' => 'data-watch="change"',
				'text' => 'Show link button if image have link'
			),
			'linkTarget' => array(
				'label' => 'Image Link Target',
				'tag' => 'select',
				'attr' => 'data-showlink="is:1"',
				'text' => 'Open image link in parent window or in new tab',
				'choices' => array(
					array(
						'label' => 'Parent Window',
						'value' => '_self'
					),
					array(
						'label' => 'New Tab',
						'value' => '_blank'
					)
				)
			),
			'property0' => array(
				'label' => 'Wmode for flash object',
				'tag' => 'select',
				'attr' => 'data-watch="change"',
				'text' => 'Default value: Opaque. If \'transparent\' - "Background Color" option is ignored, but you can position the absolute elements over the flash',
				'choices' => array(
					array(
						'label' => 'Opaque',
						'value' => 'opaque'
					),
					array(
						'label' => 'Window',
						'value' => 'window'
					),
					array(
						'label' => 'Transparent',
						'value' => 'transparent'
					)
				)
			),
			'property1' => array(
				'label' => 'Background Color',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color" data-property0="not:transparent"',
				'text' => 'Set gallery background color'
			),
			'property6' => array(
				'label' => 'Header & Footer Background Color',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color"',
				'text' => ''
			),
			'property7' => array(
				'label' => 'Buttons Color',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color"',
				'text' => ''
			),
			'property8' => array(
				'label' => 'Buttons Color on MouseOver',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color"',
				'text' => ''
			),
			'property4' => array(
				'label' => 'Show description',
				'tag' => 'checkbox',
				'attr' => 'data-watch="change"',
				'text' => 'Show image description on mouseover'
			),
			'property15' => array(
				'label' => 'Image Title Color',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color" data-property4="is:1"',
				'text' => 'Color for image title text'
			),
			'titleFontSize' => array(
				'label' => 'Image Title Font Size',
				'tag' => 'input',
				'attr' => 'type="number" min="10" max="30" data-property4="is:1"',
				'text' => ''
			),
			'property16' => array(
				'label' => 'Image Description Color',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color" data-property4="is:1"',
				'text' => 'Color of text for image description'
			),
			'descriptionFontSize' => array(
				'label' => 'Image Description Font Size',
				'tag' => 'input',
				'attr' => 'type="number" min="10" max="30" data-property4="is:1"',
				'text' => ''
			),
			'property13' => array(
				'label' => 'Description BG Color',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color" data-property4="is:1"',
				'text' => 'Background for the image description that appears on mouseover'
			),
			'property14' => array(
				'label' => 'Image Description Background Alpha',
				'tag' => 'input',
				'attr' => 'type="number" min="0" max="100" step="5" data-property4="is:1"',
				'text' => 'Opacity of the image description background'
			)
			/*,
			'backButtonTextColor' => array(
				'label' => 'Back Button Text Color',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color"',
				'text' => '(only for Full Window template). Default: ffffff'
			),
			'backButtonBgColor' => array(
				'label' => 'Back Button Background Color',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color"',
				'desc'  => '(only for Full Window template). Default: 000000'
			)*/
		)
	),
	array(
		'label' => 'Advanced Settings',
		'fields' => array(
			'customCSS' => array(
				'label' => 'Custom CSS',
				'tag' => 'textarea',
				'attr' => 'cols="20" rows="10"',
				'text' => 'You can enter custom style rules into this box if you\'d like. IE: <i>a{color: red !important;}</i><br />This is an advanced option! This is not recommended for users not fluent in CSS... but if you do know CSS, anything you add here will override the default styles'
			)
			/*,
			'loveLink' => array(
				'label' => 'Display LoveLink?',
				'tag' => 'checkbox',
				'attr' => '',
				'text' => 'Selecting "Yes" will show the lovelink icon (codeasily.com) somewhere on the gallery'
			)*/
		)
	)
);
